/* -------------------------------------------------------------------------- */
/* Copyright 2002-2023, OpenNebula Project, OpenNebula Systems                */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */

define(function(require) {

    var TemplateInfo = require('hbs!./template/html');
    var Locale = require('utils/locale');
    var TemplateUtils = require('utils/template-utils');
    /*
      CONSTANTS
     */

    var TAB_ID = require('../tabId');
    var PANEL_ID = require('./template/panelId');
    var RESOURCE = "VNTemplate"
    var XML_ROOT = "VNTEMPLATE"

    /*
      CONSTRUCTOR
     */

    function Panel(info) {
      this.tabId = TAB_ID;
      this.resource = RESOURCE;

      this.title = Locale.tr("Template");
      this.icon = "fa-file";

      this.element = info[XML_ROOT];

      return this;
    };

    Panel.PANEL_ID = PANEL_ID;
    Panel.prototype.html = _html;
    Panel.prototype.setup = _setup;

    return Panel;

    /*
        FUNCTION DEFINITIONS
    */

    function _html() {
        return TemplateInfo({
            'element': this.element,
            'templateString': TemplateUtils.templateToString(this.element.TEMPLATE)
        });
    }

    function _setup(context) {
    }
});
